Settings

There are several slicer properties that can be used to customize the slicer's view and behavior. They are listed below:

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.js
index.html
styles.css
Copy to CodeMine

disableResizingAndMoving: When the 'disableResizingAndMoving' property is true, and the mouse is pressed on the slicer, there are no resizing indicators and the slicer cannot be moved or resized; however, the slicer can be filtered using the mouse or unfiltered by selecting the 'clearFilter' button.

isLocked: When the sheet is not protected, the slicer's 'isLocked' property does not take effect. When the sheet is protected and the slicer's 'isLocked' property is true, no resizing indicator is shown and the slicer cannot be moved or resized with the mouse. The slicer cannot be filtered with the mouse or unfiltered by clicking the 'clearFilter' button.

sortState: The 'sortState' indicates the sorting order of the slicer items. The type of the 'sortState' property is GC.Spread.Sheets.SortState. Its default value is GC.Spread.Sheets.SortState.ascending.

dynamicMove and dynamicSize: When 'dynamicMove' and 'dynamicSize' properties are different, and the sheet's row or column is changed, the slicer's behavior is different.

  • Move and size with cells: dynamicMove property is true and dynamicSize property is true.
  • Move and don't size with cells: dynamicMove property is true and dynamicSize property is false.
  • Don't move and size with cells: dynamicMove property is false, and dynamicSize property is true or false.

style: SpreadJS supports 14 kinds of built-in slicer styles. You can use the built-in slicer style to change the slicer's view with the following code:

    slicer.style(GC.Spread.Sheets.Slicers.SlicerStyles.dark3().name());

The default style of the slicer is GC.Spread.Sheets.Slicers.SlicerStyles.light1().

SpreadJS supports customize the theme of the table slicer. Using code such as the following:

    const customTheme = new GC.Spread.Sheets.Slicers.SlicerStyle();
    customTheme.name("custom0");
    const wholeSlicerStyle = new GC.Spread.Sheets.Slicers.SlicerStyleInfo('red', 'white', '16px Calibri');
    customTheme.wholeSlicerStyle(wholeSlicerStyle);
    spread.customSlicerThemes.add(customTheme);

    slicer.style('custom0');

    // set default table theme
    spread.defaultSlicerTheme('custom0');
disableResizingAndMoving: When the 'disableResizingAndMoving' property is true, and the mouse is pressed on the slicer, there are no resizing indicators and the slicer cannot be moved or resized; however, the slicer can be filtered using the mouse or unfiltered by selecting the 'clearFilter' button. isLocked: When the sheet is not protected, the slicer's 'isLocked' property does not take effect. When the sheet is protected and the slicer's 'isLocked' property is true, no resizing indicator is shown and the slicer cannot be moved or resized with the mouse. The slicer cannot be filtered with the mouse or unfiltered by clicking the 'clearFilter' button. sortState: The 'sortState' indicates the sorting order of the slicer items. The type of the 'sortState' property is GC.Spread.Sheets.SortState. Its default value is GC.Spread.Sheets.SortState.ascending. dynamicMove and dynamicSize: When 'dynamicMove' and 'dynamicSize' properties are different, and the sheet's row or column is changed, the slicer's behavior is different. Move and size with cells: dynamicMove property is true and dynamicSize property is true. Move and don't size with cells: dynamicMove property is true and dynamicSize property is false. Don't move and size with cells: dynamicMove property is false, and dynamicSize property is true or false. style: SpreadJS supports 14 kinds of built-in slicer styles. You can use the built-in slicer style to change the slicer's view with the following code: The default style of the slicer is GC.Spread.Sheets.Slicers.SlicerStyles.light1(). SpreadJS supports customize the theme of the table slicer. Using code such as the following:
window.onload = function () { var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss")); initCustomThemes(spread); spread.suspendPaint(); var sheet = spread.getActiveSheet(); var dataColumns = ["Name", "City", "Birthday", "Sex", "Weight", "Height"]; var data = [ ["Bob", "NewYork", "1968/6/8", "man", "80", "180"], ["Betty", "NewYork", "1972/7/3", "woman", "72", "168"], ["Gary", "NewYork", "1964/3/2", "man", "71", "179"], ["Hunk", "Washington", "1972/8/8", "man", "80", "171"], ["Cherry", "Washington", "1986/2/2", "woman", "58", "161"], ["Eva", "Washington", "1993/2/15", "woman", "71", "180"]]; sheet.tables.addFromDataSource("table1", 1, 1, data); sheet.getRange(-1, 1, -1, 6).width(80); var table = sheet.tables.findByName("table1"); table.setColumnName(0, dataColumns[0]); table.setColumnName(1, dataColumns[1]); table.setColumnName(2, dataColumns[2]); table.setColumnName(3, dataColumns[3]); table.setColumnName(4, dataColumns[4]); table.setColumnName(5, dataColumns[5]); var slicer1 = sheet.slicers.add("slicer1", "table1", "Height"); slicer1.position(new GC.Spread.Sheets.Point(100, 180)); bindSlicerEvent(spread); spread.resumePaint(); _disableInput(); document.getElementById('protect_sheet').disabled = false; clearSlicerSetting(); }; function initCustomThemes(spread) { const theme1 = new GC.Spread.Sheets.Slicers.SlicerStyle(); theme1.fromJSON(GC.Spread.Sheets.Slicers.SlicerStyles.light1().toJSON()); theme1.name('custom1'); theme1.wholeSlicerStyle(new GC.Spread.Sheets.Slicers.SlicerStyleInfo('rgb(225, 245, 254)')); const theme2 = new GC.Spread.Sheets.Slicers.SlicerStyle(); theme2.fromJSON(GC.Spread.Sheets.Slicers.SlicerStyles.other2().toJSON()); theme2.name('custom2'); const wholeSlicerStyle = new GC.Spread.Sheets.Slicers.SlicerStyleInfo(); wholeSlicerStyle.backColor('#e3f2fd'); theme2.wholeSlicerStyle(wholeSlicerStyle); spread.customSlicerThemes.add(theme1); spread.customSlicerThemes.add(theme2); } function bindSlicerEvent(spread) { spread.bind(GC.Spread.Sheets.Events.SlicerChanged, function (event, args) { var sheet = args.sheet; var slicer = args.slicer; if (!slicer) { return; } var propertyName = args.propertyName; if (propertyName === "isSelected") { if (slicer.isSelected()) { _activeInput() initSlicerSetting(sheet, slicer); } else { _disableInput(); document.getElementById('protect_sheet').disabled = false; } } }); var sheet = spread.getActiveSheet(); // protect sheet document.getElementById('protect_sheet').onchange = function (e) { sheet.options.isProtected = e.target.checked; }; // slicer sort state document.getElementById('sort_state').onchange = function (e) { setSlicerProperty({sheet: sheet}, "sortState", e.target.value); }; // lock slicer document.getElementById('lock_slicer').onchange = function (e) { setSlicerProperty({sheet: sheet}, "isLocked", e.target.checked); }; // slicer dynamic move and dynamic size document.getElementById('slicer_move_size').onchange = function (e) { setSlicerProperty({sheet: sheet}, "moveAndSize", e.target.checked); }; document.getElementById('slicer_move_no_size').onchange = function (e) { setSlicerProperty({sheet: sheet}, "moveAndNoSize", e.target.checked); }; document.getElementById('slicer_no_move_size').onchange = function (e) { setSlicerProperty({sheet: sheet}, "noMoveAndSize", e.target.checked); }; document.getElementById('slicer_style').onchange = function (e) { const styleName = document.getElementById('slicer_style').value; if (styleName) { setSlicerProperty({sheet: sheet}, "style", styleName); } }; } function setSlicerProperty(data, property, value) { var sheet = data && data.sheet; if (!needChangeSlicer(sheet)) { return; } var selectedSlicers = getSelectedSlicers(sheet); for (var item in selectedSlicers) { var slicer = selectedSlicers[item]; switch (property) { case "sortState": slicer.sortState(GC.Spread.Sheets.SortState[value]); break; case "isLocked": slicer.isLocked(value); break; case "moveAndSize": slicer.dynamicMove(true); slicer.dynamicSize(true); break; case "moveAndNoSize": slicer.dynamicMove(true); slicer.dynamicSize(false); break; case "noMoveAndSize": slicer.dynamicMove(false); slicer.dynamicSize(false); break; case "style": slicer.style(value); break; } } } function initSlicerSetting(sheet, slicer) { document.getElementById('sort_state').value = slicer.sortState() === 1 ? "ascending" :(slicer.sortState() === 2 ? "descending" : ""); document.getElementById('protect_sheet').checked = sheet.isProtected; document.getElementById('lock_slicer').checked = slicer.isLocked(); var dynamicMove = slicer.dynamicMove(), dynamicSize = slicer.dynamicSize(); if (!dynamicMove) { document.getElementById('slicer_no_move_size').checked = true; } if (dynamicMove && !dynamicSize) { document.getElementById('slicer_move_no_size').checked = true; } if (dynamicMove && dynamicSize) { document.getElementById('slicer_move_size').checked = true; } } function clearSlicerSetting() { document.getElementById('sort_state').value = 'ascending'; document.getElementById('protect_sheet').checked = false; document.getElementById('lock_slicer').checked = true; document.getElementById('slicer_move_size').checked = true; } function getSelectedSlicers(sheet) { if (!sheet) { return null; } var slicers = sheet.slicers.all(); if (!slicers || _isEmptyObject(slicers)) { return null; } var selectedSlicers = []; for (var item in slicers) { var slicer = slicers[item]; if (slicer.isSelected()) { selectedSlicers.push(slicer); } } return selectedSlicers; } function needChangeSlicer(sheet) { if (!sheet) { return false; } var selectedSlicers = getSelectedSlicers(sheet); if (!selectedSlicers || selectedSlicers.length === 0) { return false; } return true; } function _disableInput() { var inputs = document.querySelectorAll('.option-group input, .option-group select'); for (var inputIndex = 0; inputIndex < inputs.length; inputIndex++) { inputs[inputIndex].disabled = "disabled"; } } function _activeInput() { var inputs = document.querySelectorAll('.option-group input, .option-group select'); for (var inputIndex = 0; inputIndex < inputs.length; inputIndex++) { inputs[inputIndex].disabled = false; } } function _isEmptyObject(obj) { var name; for (name in obj) { return false; } return true; }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-slicers/dist/gc.spread.sheets.slicers.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div class="options-container"> <p>Select the slicer and then change the options.</p> <div class="option-group"> <label for="sort_state">Sort State:</label> <select id="sort_state"> <option value="none">none</option> <option value="ascending">ascending</option> <option value="descending">descending</option> </select> </div> <div class="option-group"> <label for="slicer_style">Styles:</label> <select id="slicer_style"> <option value="light1">Light1</option> <option value="light2">Light2</option> <option value="light3">Light3</option> <option value="light4">Light4</option> <option value="light5">Light5</option> <option value="light6">Light6</option> <option value="other1">Other1</option> <option value="other2">Other2</option> <option value="dark1">Dark1</option> <option value="dark2">Dark2</option> <option value="dark3">Dark3</option> <option value="dark4">Dark4</option> <option value="dark5">Dark5</option> <option value="dark6">Dark6</option> <option value="custom1">Custom1</option> <option value="custom2">Custom2</option> </select> </div> <hr> <div class="option-group"> <input type="checkbox" id="protect_sheet" /> <label for="protect_sheet">Protect Sheet</label> </div> <div class="option-group"> <input type="checkbox" id="lock_slicer" checked /> <label for="lock_slicer">Lock Slicer</label> </div> <hr> <div class="option-group"> <input type="radio" name="dynamic_move_size" value="move_size" id="slicer_move_size" checked /> <label for="slicer_move_size">Move and size with cells</label> </div> <div class="option-group"> <input type="radio" name="dynamic_move_size" value="move_no_size" id="slicer_move_no_size" /> <label for="slicer_move_no_size">Move and don't size with cells</label> </div> <div class="option-group"> <input type="radio" name="dynamic_move_size" value="no_move_size" id="slicer_no_move_size" /> <label for="slicer_no_move_size">Don't move and size with cells</label> </div> </div> </div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: auto; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-group { margin-bottom: 6px; } label { display: inline-block; min-width: 90px; margin: 6px 0; } input { padding: 4px 6px; box-sizing: border-box; margin-bottom: 6px; } hr { border-color: #fff; opacity: .2; margin: 12px 0; } p { padding: 2px 10px; background-color: #F4F8EB; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }

disableResizingAndMoving: When the 'disableResizingAndMoving' property is true, and the mouse is pressed on the slicer, there are no resizing indicators and the slicer cannot be moved or resized; however, the slicer can be filtered using the mouse or unfiltered by selecting the 'clearFilter' button.
isLocked: When the sheet is not protected, the slicer's 'isLocked' property does not take effect. When the sheet is protected and the slicer's 'isLocked' property is true, no resizing indicator is shown and the slicer cannot be moved or resized with the mouse. The slicer cannot be filtered with the mouse or unfiltered by clicking the 'clearFilter' button.
sortState: The 'sortState' indicates the sorting order of the slicer items. The type of the 'sortState' property is GC.Spread.Sheets.SortState. Its default value is GC.Spread.Sheets.SortState.ascending.
dynamicMove and dynamicSize: When 'dynamicMove' and 'dynamicSize' properties are different, and the sheet's row or column is changed, the slicer's behavior is different.
Move and size with cells: dynamicMove property is true and dynamicSize property is true.
Move and don't size with cells: dynamicMove property is true and dynamicSize property is false.
Don't move and size with cells: dynamicMove property is false, and dynamicSize property is true or false.
style: SpreadJS supports 14 kinds of built-in slicer styles. You can use the built-in slicer style to change the slicer's view with the following code:
The default style of the slicer is GC.Spread.Sheets.Slicers.SlicerStyles.light1().
SpreadJS supports customize the theme of the table slicer. Using code such as the following:
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
</gc-spread-sheets>
<div class="options-container">
<p>Select the slicer and then change the options.</p>
<div class="option-group">
<label for="sort_state">Sort State:</label>
<select id="sort_state" :disabled="disableForm" v-model.number="sortState" @change="updateSortState">
<option value=0>none</option>
<option value=1>ascending</option>
<option value=2>descending</option>
</select>
</div>
<div class="option-group">
<label for="slicer_style">Styles:</label>
<select id="slicer_style" :disabled="disableForm" v-model="styleName" @change="updateStyleName">
<option value="light1">Light1</option>
<option value="light2">Light2</option>
<option value="light3">Light3</option>
<option value="light4">Light4</option>
<option value="light5">Light5</option>
<option value="light6">Light6</option>
<option value="other1">Other1</option>
<option value="other2">Other2</option>
<option value="dark1">Dark1</option>
<option value="dark2">Dark2</option>
<option value="dark3">Dark3</option>
<option value="dark4">Dark4</option>
<option value="dark5">Dark5</option>
<option value="dark6">Dark6</option>
<option value="custom1">Custom1</option>
<option value="custom2">Custom2</option>
</select>
</div>
<hr>
<div class="option-group">
<input type="checkbox" id="protect_sheet" v-model="protectSheet" @change="updateProtectSheet" />
<label for="protect_sheet">Protect Sheet</label>
</div>
<div class="option-group">
<input type="checkbox" id="lock_slicer" :disabled="disableForm" v-model="lockSlicer"
@change="updateLockSlicer" />
<label for="lock_slicer">Lock Slicer</label>
</div>
<hr>
<div class="option-group">
<input type="radio" name="dynamic_move_size" id="slicer_move_size" :disabled="disableForm"
:checked="dynamicMove && dynamicSize" @change="movesize" />
<label for="slicer_move_size">Move and size with cells</label>
</div>
<div class="option-group">
<input type="radio" name="dynamic_move_size" :disabled="disableForm" id="slicer_move_no_size"
:checked="dynamicMove && !dynamicSize" @change="movenosize" />
<label for="slicer_move_no_size">Move and don't size with cells</label>
</div>
<div class="option-group">
<input type="radio" name="dynamic_move_size" :disabled="disableForm" id="slicer_no_move_size"
:checked="!dynamicMove && !dynamicSize" @change="nomovesize" />
<label for="slicer_no_move_size">Don't move and size with cells</label>
</div>
</div>
</div>
</template>
<script setup>
import '@mescius/spread-sheets-vue';
import '@mescius/spread-sheets-slicers';
import { ref } from "vue";
import GC from "@mescius/spread-sheets";
const spreadRef = ref(null);
const sortState = ref(0);
const styleName = ref('light1');
const protectSheet = ref(true);
const lockSlicer = ref(true);
const dynamicMove = ref(true);
const dynamicSize = ref(false);
const selectedSlicersList = ref([]);
const disableForm = ref(true);
const getSelectedSlicers = (sheet) => {
if (!sheet) {
return null;
}
let slicers = sheet.slicers.all();
if (!slicers || _isEmptyObject(slicers)) {
return null;
}
let selectedSlicersList = [];
for (let item in slicers) {
let slicer = slicers[item];
if (slicer.isSelected()) {
selectedSlicersList.push(slicer);
}
}
return selectedSlicersList;
}
const _isEmptyObject = (obj) => {
for (let name in obj) {
return false;
}
return true;
}
const updateProtectSheet = () => {
spreadRef.value.getActiveSheet().options.isProtected = protectSheet.value;
}
const updateSortState = () => {
selectedSlicersList.value.forEach((slicer) => {
slicer.sortState(sortState.value);
});
}
const updateStyleName = () => {
selectedSlicersList.value.forEach((slicer) => {
slicer.style(styleName.value);
});
}
const updateLockSlicer = () => {
selectedSlicersList.value.forEach((slicer) => {
slicer.isLocked(lockSlicer.value);
});
}
const updateMoveSize = () => {
selectedSlicersList.value.forEach((slicer) => {
slicer.dynamicMove(dynamicMove.value);
slicer.dynamicSize(dynamicSize.value);
});
}
const movesize = () => {
dynamicMove.value = true;
dynamicSize.value = true;
updateMoveSize();
}
const movenosize = () => {
dynamicMove.value = true;
dynamicSize.value = false;
updateMoveSize();
}
const nomovesize = () => {
dynamicMove.value = false;
dynamicSize.value = false;
updateMoveSize();
}
const initSpread = (spread) => {
spreadRef.value = spread;
initCustomThemes(spread);
spread.suspendPaint();
var sheet = spread.getActiveSheet();
var dataColumns = ["Name", "City", "Birthday", "Sex", "Weight", "Height"];
var data = [
["Bob", "NewYork", "1968/6/8", "man", "80", "180"],
["Betty", "NewYork", "1972/7/3", "woman", "72", "168"],
["Gary", "NewYork", "1964/3/2", "man", "71", "179"],
["Hunk", "Washington", "1972/8/8", "man", "80", "171"],
["Cherry", "Washington", "1986/2/2", "woman", "58", "161"],
["Eva", "Washington", "1993/2/15", "woman", "71", "180"]
];
sheet.tables.addFromDataSource("table1", 1, 1, data);
sheet.getRange(-1, 1, -1, 6).width(80);
var table = sheet.tables.findByName("table1");
table.setColumnName(0, dataColumns[0]);
table.setColumnName(1, dataColumns[1]);
table.setColumnName(2, dataColumns[2]);
table.setColumnName(3, dataColumns[3]);
table.setColumnName(4, dataColumns[4]);
table.setColumnName(5, dataColumns[5]);
var slicer1 = sheet.slicers.add("slicer1", "table1", "Height");
slicer1.position(new GC.Spread.Sheets.Point(100, 180));
bindSlicerEvent(spread);
spread.resumePaint();
}
const initCustomThemes = (spread) => {
const theme1 = new GC.Spread.Sheets.Slicers.SlicerStyle();
theme1.fromJSON(GC.Spread.Sheets.Slicers.SlicerStyles.light1().toJSON());
theme1.name('custom1');
theme1.wholeSlicerStyle(new GC.Spread.Sheets.Slicers.SlicerStyleInfo('rgb(225, 245, 254)'));
const theme2 = new GC.Spread.Sheets.Slicers.SlicerStyle();
theme2.fromJSON(GC.Spread.Sheets.Slicers.SlicerStyles.other2().toJSON());
theme2.name('custom2');
const wholeSlicerStyle = new GC.Spread.Sheets.Slicers.SlicerStyleInfo();
wholeSlicerStyle.backColor('#e3f2fd');
theme2.wholeSlicerStyle(wholeSlicerStyle);
spread.customSlicerThemes.add(theme1);
spread.customSlicerThemes.add(theme2);
}
const bindSlicerEvent = (spread) => {
spread.bind(GC.Spread.Sheets.Events.SlicerChanged, function (event, args) {
var sheet = args.sheet;
var slicer = args.slicer;
if (!slicer) {
return;
}
var propertyName = args.propertyName;
if (propertyName === "isSelected") {
if (slicer.isSelected()) {
initSlicerSetting(sheet, slicer);
selectedSlicersList.value = getSelectedSlicers(sheet)
disableForm.value = false;
} else {
disableForm.value = true;
}
}
});
}
const initSlicerSetting = (sheet, slicer) => {
sortState.value = slicer.sortState();
protectSheet.value = sheet.isProtected;
lockSlicer.value = slicer.isLocked();
dynamicMove.value = slicer.dynamicMove();
dynamicSize.value = slicer.dynamicSize();
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: auto;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-group {
margin-bottom: 6px;
}
label {
display: inline-block;
min-width: 90px;
margin: 6px 0;
}
input {
padding: 4px 6px;
box-sizing: border-box;
margin-bottom: 6px;
}
hr {
border-color: #fff;
opacity: .2;
margin: 12px 0;
}
p {
padding: 2px 10px;
background-color: #F4F8EB;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-slicers': 'npm:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

disableResizingAndMoving: When the 'disableResizingAndMoving' property is true, and the mouse is pressed on the slicer, there are no resizing indicators and the slicer cannot be moved or resized; however, the slicer can be filtered using the mouse or unfiltered by selecting the 'clearFilter' button.
isLocked: When the sheet is not protected, the slicer's 'isLocked' property does not take effect. When the sheet is protected and the slicer's 'isLocked' property is true, no resizing indicator is shown and the slicer cannot be moved or resized with the mouse. The slicer cannot be filtered with the mouse or unfiltered by clicking the 'clearFilter' button.
sortState: The 'sortState' indicates the sorting order of the slicer items. The type of the 'sortState' property is GC.Spread.Sheets.SortState. Its default value is GC.Spread.Sheets.SortState.ascending.
dynamicMove and dynamicSize: When 'dynamicMove' and 'dynamicSize' properties are different, and the sheet's row or column is changed, the slicer's behavior is different.
Move and size with cells: dynamicMove property is true and dynamicSize property is true.
Move and don't size with cells: dynamicMove property is true and dynamicSize property is false.
Don't move and size with cells: dynamicMove property is false, and dynamicSize property is true or false.
style: SpreadJS supports 14 kinds of built-in slicer styles. You can use the built-in slicer style to change the slicer's view with the following code:
The default style of the slicer is GC.Spread.Sheets.Slicers.SlicerStyles.light1().
SpreadJS supports customize the theme of the table slicer. Using code such as the following:
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-slicers";
let spread = null;
export function AppFunc() {
const [slicerSetting, setSlicerSetting] = React.useState({
spread: null,
sortState: 0,
styleName: 'light1',
protectSheet: true,
lockSlicer: true,
dynamicMove: true,
dynamicSize: false,
selectedSlicersList: [],
disableForm: true
});
const updateProtectSheet = (event) => {
let checked = event.target.checked;
setSlicerSetting({ ...slicerSetting, protectSheet: checked });
spread.getActiveSheet().options.isProtected = checked;
}
const updateSortState = (event) => {
let sortState = parseInt(event.target.value, 10);
setSlicerSetting({ ...slicerSetting, sortState: sortState });
slicerSetting.selectedSlicersList.forEach((slicer) => {
slicer.sortState(sortState);
});
}
const updateStyleName = (event) => {
let styleName = event.target.value;
setSlicerSetting({ ...slicerSetting, styleName: styleName });
slicerSetting.selectedSlicersList.forEach((slicer) => {
slicer.style(styleName);
});
}
const updateLockSlicer = (event) => {
let checked = event.target.checked;
setSlicerSetting({ ...slicerSetting, lockSlicer: checked });
slicerSetting.selectedSlicersList.forEach((slicer) => {
slicer.isLocked(checked);
});
}
const updateMoveSize = (dynamicMove, dynamicSize) => {
slicerSetting.selectedSlicersList.forEach((slicer) => {
slicer.dynamicMove(dynamicMove);
slicer.dynamicSize(dynamicSize);
});
}
const movesize = () => {
setSlicerSetting({ ...slicerSetting, dynamicMove: true, dynamicSize: true });
updateMoveSize(true, true);
}
const movenosize = () => {
setSlicerSetting({ ...slicerSetting, dynamicMove: true, dynamicSize: false });
updateMoveSize(true, false);
}
const nomovesize = () => {
setSlicerSetting({ ...slicerSetting, dynamicMove: false, dynamicSize: false });
updateMoveSize(false, false);
}
const initSpread = (currSpread) => {
spread = currSpread;
initCustomThemes();
spread.suspendPaint();
var sheet = spread.getActiveSheet();
var dataColumns = ["Name", "City", "Birthday", "Sex", "Weight", "Height"];
var data = [
["Bob", "NewYork", "1968/6/8", "man", "80", "180"],
["Betty", "NewYork", "1972/7/3", "woman", "72", "168"],
["Gary", "NewYork", "1964/3/2", "man", "71", "179"],
["Hunk", "Washington", "1972/8/8", "man", "80", "171"],
["Cherry", "Washington", "1986/2/2", "woman", "58", "161"],
["Eva", "Washington", "1993/2/15", "woman", "71", "180"]
];
sheet.tables.addFromDataSource("table1", 1, 1, data);
sheet.getRange(-1, 1, -1, 6).width(80);
var table = sheet.tables.findByName("table1");
table.setColumnName(0, dataColumns[0]);
table.setColumnName(1, dataColumns[1]);
table.setColumnName(2, dataColumns[2]);
table.setColumnName(3, dataColumns[3]);
table.setColumnName(4, dataColumns[4]);
table.setColumnName(5, dataColumns[5]);
var slicer1 = sheet.slicers.add("slicer1", "table1", "Height");
slicer1.position(new GC.Spread.Sheets.Point(100, 180));
bindSlicerEvent();
spread.resumePaint();
}
const initCustomThemes = () => {
const theme1 = new GC.Spread.Sheets.Slicers.SlicerStyle();
theme1.fromJSON(GC.Spread.Sheets.Slicers.SlicerStyles.light1().toJSON());
theme1.name('custom1');
theme1.wholeSlicerStyle(new GC.Spread.Sheets.Slicers.SlicerStyleInfo('rgb(225, 245, 254)'));
const theme2 = new GC.Spread.Sheets.Slicers.SlicerStyle();
theme2.fromJSON(GC.Spread.Sheets.Slicers.SlicerStyles.other2().toJSON());
theme2.name('custom2');
const wholeSlicerStyle = new GC.Spread.Sheets.Slicers.SlicerStyleInfo();
wholeSlicerStyle.backColor('#e3f2fd');
theme2.wholeSlicerStyle(wholeSlicerStyle);
spread.customSlicerThemes.add(theme1);
spread.customSlicerThemes.add(theme2);
}
const bindSlicerEvent = () => {
spread.bind(GC.Spread.Sheets.Events.SlicerChanged, function (event, args) {
var sheet = args.sheet;
var slicer = args.slicer;
if (!slicer) {
return;
}
var propertyName = args.propertyName;
if (propertyName === "isSelected") {
if (slicer.isSelected()) {
initSlicerSetting(sheet, slicer);
setSlicerSetting((setting) => ({ ...setting, disableForm: false, selectedSlicersList: getSelectedSlicers(sheet) }));
} else {
setSlicerSetting((setting) => ({ ...setting, disableForm: true }));
}
}
});
}
const initSlicerSetting = (sheet, slicer) => {
setSlicerSetting((setting) => ({
...setting,
sortState: slicer.sortState(),
protectSheet: sheet.isProtected,
lockSlicer: slicer.isLocked(),
dynamicMove: slicer.dynamicMove(),
dynamicSize: slicer.dynamicSize()
}));
}
return (<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
</SpreadSheets>
</div>
<div class="options-container">
<p>Select the slicer and then change the options.</p>
<div class="option-group">
<label for="sort_state">Sort State:</label>
<select id="sort_state" disabled={slicerSetting.disableForm} value={slicerSetting.sortState} onChange={(event) => { updateSortState(event) }}>
<option value={0}>none</option>
<option value={1}>ascending</option>
<option value={2}>descending</option>
</select>
</div>
<div class="option-group">
<label for="slicer_style">Styles:</label>
<select id="slicer_style" disabled={slicerSetting.disableForm} value={slicerSetting.styleName} onChange={(event) => { updateStyleName(event) }}>
<option value="light1">Light1</option>
<option value="light2">Light2</option>
<option value="light3">Light3</option>
<option value="light4">Light4</option>
<option value="light5">Light5</option>
<option value="light6">Light6</option>
<option value="other1">Other1</option>
<option value="other2">Other2</option>
<option value="dark1">Dark1</option>
<option value="dark2">Dark2</option>
<option value="dark3">Dark3</option>
<option value="dark4">Dark4</option>
<option value="dark5">Dark5</option>
<option value="dark6">Dark6</option>
<option value="custom1">Custom1</option>
<option value="custom2">Custom2</option>
</select>
</div>
<hr />
<div class="option-group">
<input type="checkbox" id="protect_sheet" value={slicerSetting.protectSheet} onChange={(event) => updateProtectSheet(event)} />
<label for="protect_sheet">Protect Sheet</label>
</div>
<div class="option-group">
<input type="checkbox" id="lock_slicer" disabled={slicerSetting.disableForm} value={slicerSetting.lockSlicer} onChange={(event) => { updateLockSlicer(event) }} />
<label for="lock_slicer">Lock Slicer</label>
</div>
<hr />
<div class="option-group">
<input type="radio" name="dynamic_move_size" id="slicer_move_size" disabled={slicerSetting.disableForm} checked={slicerSetting.dynamicMove && slicerSetting.dynamicSize} onChange={(event) => { movesize() }} />
<label for="slicer_move_size">Move and size with cells</label>
</div>
<div class="option-group">
<input type="radio" name="dynamic_move_size" disabled={slicerSetting.disableForm} id="slicer_move_no_size" checked={slicerSetting.dynamicMove && !slicerSetting.dynamicSize} onChange={(event) => { movenosize() }} />
<label for="slicer_move_no_size">Move and don't size with cells</label>
</div>
<div class="option-group">
<input type="radio" name="dynamic_move_size" disabled={slicerSetting.disableForm} id="slicer_no_move_size" checked={!slicerSetting.dynamicMove && !slicerSetting.dynamicSize} onChange={(event) => { nomovesize() }} />
<label for="slicer_no_move_size">Don't move and size with cells</label>
</div>
</div>
</div>);
}
const getSelectedSlicers = (sheet) => {
if (!sheet) {
return null;
}
let slicers = sheet.slicers.all();
if (!slicers || _isEmptyObject(slicers)) {
return null;
}
let selectedSlicersList = [];
for (let item in slicers) {
let slicer = slicers[item];
if (slicer.isSelected()) {
selectedSlicersList.push(slicer);
}
}
return selectedSlicersList;
}
const _isEmptyObject = (obj) => {
for (let name in obj) {
return false;
}
return true;
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-slicers";
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.state = {
spread: null,
sortState: 0,
styleName: 'light1',
protectSheet: true,
lockSlicer: true,
dynamicMove: true,
dynamicSize: false,
selectedSlicersList: [],
disableForm: true
}
}
render() {
return (<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
<div class="options-container">
<p>Select the slicer and then change the options.</p>
<div class="option-group">
<label for="sort_state">Sort State:</label>
<select id="sort_state" disabled={this.state.disableForm} value={this.state.sortState} onChange={(event) => { this.updateSortState(event) }}>
<option value={0}>none</option>
<option value={1}>ascending</option>
<option value={2}>descending</option>
</select>
</div>
<div class="option-group">
<label for="slicer_style">Styles:</label>
<select id="slicer_style" disabled={this.state.disableForm} value={this.state.styleName} onChange={(event) => { this.updateStyleName(event) }}>
<option value="light1">Light1</option>
<option value="light2">Light2</option>
<option value="light3">Light3</option>
<option value="light4">Light4</option>
<option value="light5">Light5</option>
<option value="light6">Light6</option>
<option value="other1">Other1</option>
<option value="other2">Other2</option>
<option value="dark1">Dark1</option>
<option value="dark2">Dark2</option>
<option value="dark3">Dark3</option>
<option value="dark4">Dark4</option>
<option value="dark5">Dark5</option>
<option value="dark6">Dark6</option>
<option value="custom1">Custom1</option>
<option value="custom2">Custom2</option>
</select>
</div>
<hr />
<div class="option-group">
<input type="checkbox" id="protect_sheet" value={this.state.protectSheet} onChange={(event) => this.updateProtectSheet(event)} />
<label for="protect_sheet">Protect Sheet</label>
</div>
<div class="option-group">
<input type="checkbox" id="lock_slicer" disabled={this.state.disableForm} value={this.state.lockSlicer} onChange={(event) => { this.updateLockSlicer(event) }} />
<label for="lock_slicer">Lock Slicer</label>
</div>
<hr />
<div class="option-group">
<input type="radio" name="dynamic_move_size" id="slicer_move_size" disabled={this.state.disableForm} checked={this.state.dynamicMove && this.state.dynamicSize} onChange={(event) => { this.movesize() }} />
<label for="slicer_move_size">Move and size with cells</label>
</div>
<div class="option-group">
<input type="radio" name="dynamic_move_size" disabled={this.state.disableForm} id="slicer_move_no_size" checked={this.state.dynamicMove && !this.state.dynamicSize} onChange={(event) => { this.movenosize() }} />
<label for="slicer_move_no_size">Move and don't size with cells</label>
</div>
<div class="option-group">
<input type="radio" name="dynamic_move_size" disabled={this.state.disableForm} id="slicer_no_move_size" checked={!this.state.dynamicMove && !this.state.dynamicSize} onChange={(event) => { this.nomovesize() }} />
<label for="slicer_no_move_size">Don't move and size with cells</label>
</div>
</div>
</div>);
}
updateProtectSheet(event) {
let checked = event.target.checked;
this.setState({ protectSheet: checked });
this.spread.getActiveSheet().options.isProtected = checked;
}
updateSortState(event) {
let sortState = parseInt(event.target.value, 10) ;
this.setState({ sortState: sortState });
this.selectedSlicersList.forEach((slicer) => {
slicer.sortState(sortState);
});
}
updateStyleName(event) {
let styleName = event.target.value;
this.setState({ styleName: styleName });
this.selectedSlicersList.forEach((slicer) => {
slicer.style(styleName);
});
}
updateLockSlicer(event) {
let checked = event.target.checked;
this.setState({ lockSlicer: checked });
this.selectedSlicersList.forEach((slicer) => {
slicer.isLocked(checked);
});
}
updateMoveSize(dynamicMove, dynamicSize) {
this.selectedSlicersList.forEach((slicer) => {
slicer.dynamicMove(dynamicMove);
slicer.dynamicSize(dynamicSize);
});
}
movesize() {
this.setState({ dynamicMove: true, dynamicSize: true });
this.updateMoveSize(true, true);
}
movenosize() {
this.setState({ dynamicMove: true, dynamicSize: false });
this.updateMoveSize(true, false);
}
nomovesize() {
this.setState({ dynamicMove: false, dynamicSize: false });
this.updateMoveSize(false, false);
}
initSpread(spread) {
this.spread = spread;
this.initCustomThemes(spread);
spread.suspendPaint();
var sheet = spread.getActiveSheet();
var dataColumns = ["Name", "City", "Birthday", "Sex", "Weight", "Height"];
var data = [
["Bob", "NewYork", "1968/6/8", "man", "80", "180"],
["Betty", "NewYork", "1972/7/3", "woman", "72", "168"],
["Gary", "NewYork", "1964/3/2", "man", "71", "179"],
["Hunk", "Washington", "1972/8/8", "man", "80", "171"],
["Cherry", "Washington", "1986/2/2", "woman", "58", "161"],
["Eva", "Washington", "1993/2/15", "woman", "71", "180"]
];
sheet.tables.addFromDataSource("table1", 1, 1, data);
sheet.getRange(-1, 1, -1, 6).width(80);
var table = sheet.tables.findByName("table1");
table.setColumnName(0, dataColumns[0]);
table.setColumnName(1, dataColumns[1]);
table.setColumnName(2, dataColumns[2]);
table.setColumnName(3, dataColumns[3]);
table.setColumnName(4, dataColumns[4]);
table.setColumnName(5, dataColumns[5]);
var slicer1 = sheet.slicers.add("slicer1", "table1", "Height");
slicer1.position(new GC.Spread.Sheets.Point(100, 180));
this.bindSlicerEvent(spread);
spread.resumePaint();
}
initCustomThemes (spread) {
const theme1 = new GC.Spread.Sheets.Slicers.SlicerStyle();
theme1.fromJSON(GC.Spread.Sheets.Slicers.SlicerStyles.light1().toJSON());
theme1.name('custom1');
theme1.wholeSlicerStyle(new GC.Spread.Sheets.Slicers.SlicerStyleInfo('rgb(225, 245, 254)'));
const theme2 = new GC.Spread.Sheets.Slicers.SlicerStyle();
theme2.fromJSON(GC.Spread.Sheets.Slicers.SlicerStyles.other2().toJSON());
theme2.name('custom2');
const wholeSlicerStyle = new GC.Spread.Sheets.Slicers.SlicerStyleInfo();
wholeSlicerStyle.backColor('#e3f2fd');
theme2.wholeSlicerStyle(wholeSlicerStyle);
spread.customSlicerThemes.add(theme1);
spread.customSlicerThemes.add(theme2);
}
bindSlicerEvent(spread) {
let self = this;
spread.bind(GC.Spread.Sheets.Events.SlicerChanged, function (event, args) {
var sheet = args.sheet;
var slicer = args.slicer;
if (!slicer) {
return;
}
var propertyName = args.propertyName;
if (propertyName === "isSelected") {
if (slicer.isSelected()) {
self.initSlicerSetting(sheet, slicer);
self.selectedSlicersList = getSelectedSlicers(sheet)
self.setState({ disableForm: false });
} else {
self.setState({ disableForm: true });
}
}
});
}
initSlicerSetting(sheet, slicer) {
this.setState({
sortState: slicer.sortState(),
protectSheet: sheet.isProtected,
lockSlicer: slicer.isLocked(),
dynamicMove: slicer.dynamicMove(),
dynamicSize: slicer.dynamicSize()
});
}
}
const getSelectedSlicers = (sheet) => {
if (!sheet) {
return null;
}
let slicers = sheet.slicers.all();
if (!slicers || _isEmptyObject(slicers)) {
return null;
}
let selectedSlicersList = [];
for (let item in slicers) {
let slicer = slicers[item];
if (slicer.isSelected()) {
selectedSlicersList.push(slicer);
}
}
return selectedSlicersList;
}
const _isEmptyObject = (obj) => {
for (let name in obj) {
return false;
}
return true;
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: auto;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-group {
margin-bottom: 6px;
}
label {
display: inline-block;
min-width: 90px;
margin: 6px 0;
}
input {
padding: 4px 6px;
box-sizing: border-box;
margin-bottom: 6px;
}
hr {
border-color: #fff;
opacity: .2;
margin: 12px 0;
}
p {
padding: 2px 10px;
background-color: #F4F8EB;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-slicers': 'npm:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

disableResizingAndMoving: When the 'disableResizingAndMoving' property is true, and the mouse is pressed on the slicer, there are no resizing indicators and the slicer cannot be moved or resized; however, the slicer can be filtered using the mouse or unfiltered by selecting the 'clearFilter' button.
isLocked: When the sheet is not protected, the slicer's 'isLocked' property does not take effect. When the sheet is protected and the slicer's 'isLocked' property is true, no resizing indicator is shown and the slicer cannot be moved or resized with the mouse. The slicer cannot be filtered with the mouse or unfiltered by clicking the 'clearFilter' button.
sortState: The 'sortState' indicates the sorting order of the slicer items. The type of the 'sortState' property is GC.Spread.Sheets.SortState. Its default value is GC.Spread.Sheets.SortState.ascending.
dynamicMove and dynamicSize: When 'dynamicMove' and 'dynamicSize' properties are different, and the sheet's row or column is changed, the slicer's behavior is different.
Move and size with cells: dynamicMove property is true and dynamicSize property is true.
Move and don't size with cells: dynamicMove property is true and dynamicSize property is false.
Don't move and size with cells: dynamicMove property is false, and dynamicSize property is true or false.
style: SpreadJS supports 14 kinds of built-in slicer styles. You can use the built-in slicer style to change the slicer's view with the following code:
The default style of the slicer is GC.Spread.Sheets.Slicers.SlicerStyles.light1().
SpreadJS supports customize the theme of the table slicer. Using code such as the following:
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-slicers";
import './styles.css';
const getSelectedSlicers = (sheet: GC.Spread.Sheets.Worksheet) => {
if (!sheet) {
return null;
}
let slicers = sheet.slicers.all();
if (!slicers || _isEmptyObject(slicers)) {
return null;
}
let selectedSlicersList = [];
for (let item in slicers) {
let slicer = slicers[item];
if (slicer.isSelected()) {
selectedSlicersList.push(slicer);
}
}
return selectedSlicersList;
}
const _isEmptyObject = (obj: object) => {
for (let name in obj) {
return false;
}
return true;
}
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook = null;
sortState = 0;
styleName = 'light1';
protectSheet = true;
lockSlicer = true;
dynamicMove = true;
dynamicSize = false;
selectedSlicersList: any[] = [];
disableForm = true;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
updateProtectSheet() {
this.spread.getActiveSheet().options.isProtected = this.protectSheet;
}
updateSortState() {
this.selectedSlicersList.forEach((slicer) => {
var sortState=parseInt(this.sortState);
slicer.sortState(sortState);
});
}
updateStyleName() {
this.selectedSlicersList.forEach((slicer) => {
slicer.style(this.styleName);
});
}
updateLockSlicer() {
this.selectedSlicersList.forEach((slicer) => {
slicer.isLocked(this.lockSlicer);
});
}
updateMoveSize() {
this.selectedSlicersList.forEach((slicer) => {
slicer.dynamicMove(this.dynamicMove);
slicer.dynamicSize(this.dynamicSize);
});
}
movesize() {
this.dynamicMove = true;
this.dynamicSize = true;
this.updateMoveSize();
}
movenosize() {
this.dynamicMove = true;
this.dynamicSize = false;
this.updateMoveSize();
}
nomovesize() {
this.dynamicMove = false;
this.dynamicSize = false;
this.updateMoveSize();
}
initSpread($event:any) {
let spread = $event.spread;
this.spread = spread;
this.initCustomThemes(spread);
spread.suspendPaint();
var sheet = spread.getActiveSheet();
var dataColumns = ["Name", "City", "Birthday", "Sex", "Weight", "Height"];
var data = [
["Bob", "NewYork", "1968/6/8", "man", "80", "180"],
["Betty", "NewYork", "1972/7/3", "woman", "72", "168"],
["Gary", "NewYork", "1964/3/2", "man", "71", "179"],
["Hunk", "Washington", "1972/8/8", "man", "80", "171"],
["Cherry", "Washington", "1986/2/2", "woman", "58", "161"],
["Eva", "Washington", "1993/2/15", "woman", "71", "180"]
];
sheet.tables.addFromDataSource("table1", 1, 1, data);
sheet.getRange(-1, 1, -1, 6).width(80);
var table = sheet.tables.findByName("table1");
table.setColumnName(0, dataColumns[0]);
table.setColumnName(1, dataColumns[1]);
table.setColumnName(2, dataColumns[2]);
table.setColumnName(3, dataColumns[3]);
table.setColumnName(4, dataColumns[4]);
table.setColumnName(5, dataColumns[5]);
var slicer1 = sheet.slicers.add("slicer1", "table1", "Height");
slicer1.position(new GC.Spread.Sheets.Point(100, 180));
this.bindSlicerEvent(spread);
spread.resumePaint();
}
initCustomThemes (spread: GC.Spread.Sheets.Workbook) {
const theme1 = new GC.Spread.Sheets.Slicers.SlicerStyle();
theme1.fromJSON(GC.Spread.Sheets.Slicers.SlicerStyles.light1().toJSON());
theme1.name('custom1');
theme1.wholeSlicerStyle(new GC.Spread.Sheets.Slicers.SlicerStyleInfo('rgb(225, 245, 254)'));
const theme2 = new GC.Spread.Sheets.Slicers.SlicerStyle();
theme2.fromJSON(GC.Spread.Sheets.Slicers.SlicerStyles.other2().toJSON());
theme2.name('custom2');
const wholeSlicerStyle = new GC.Spread.Sheets.Slicers.SlicerStyleInfo();
wholeSlicerStyle.backColor('#e3f2fd');
theme2.wholeSlicerStyle(wholeSlicerStyle);
spread.customSlicerThemes.add(theme1);
spread.customSlicerThemes.add(theme2);
}
bindSlicerEvent(spread: GC.Spread.Sheets.Workbook) {
let self = this;
spread.bind(GC.Spread.Sheets.Events.SlicerChanged, function(event: any, args: any) {
var sheet = args.sheet;
var slicer = args.slicer;
if (!slicer) {
return;
}
var propertyName = args.propertyName;
if (propertyName === "isSelected") {
if (slicer.isSelected()) {
self.initSlicerSetting(sheet, slicer);
self.selectedSlicersList = getSelectedSlicers(sheet)
self.disableForm = false;
} else {
self.disableForm = true;
}
}
});
}
initSlicerSetting(sheet: GC.Spread.Sheets.Worksheet, slicer: GC.Spread.Sheets.Slicers.Slicer) {
this.sortState = slicer.sortState();
this.protectSheet = sheet.isProtected;
this.lockSlicer = slicer.isLocked();
this.dynamicMove = slicer.dynamicMove();
this.dynamicSize = slicer.dynamicSize();
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div class="options-container">
<p>Select the slicer and then change the options.</p>
<div class="option-group">
<label for="sort_state">Sort State:</label>
<select id="sort_state" [disabled]="disableForm" [(ngModel)]="sortState" [value]="sortState|number" (change)="updateSortState()">
<option value=0>none</option>
<option value=1>ascending</option>
<option value=2>descending</option>
</select>
</div>
<div class="option-group">
<label for="slicer_style">Styles:</label>
<select id="slicer_style" [disabled]="disableForm" [(ngModel)]="styleName" (change)="updateStyleName()">
<option value="light1">Light1</option>
<option value="light2">Light2</option>
<option value="light3">Light3</option>
<option value="light4">Light4</option>
<option value="light5">Light5</option>
<option value="light6">Light6</option>
<option value="other1">Other1</option>
<option value="other2">Other2</option>
<option value="dark1">Dark1</option>
<option value="dark2">Dark2</option>
<option value="dark3">Dark3</option>
<option value="dark4">Dark4</option>
<option value="dark5">Dark5</option>
<option value="dark6">Dark6</option>
<option value="custom1">Custom1</option>
<option value="custom2">Custom2</option>
</select>
</div>
<hr>
<div class="option-group">
<input type="checkbox" id="protect_sheet" [(ngModel)]="protectSheet" (change)="updateProtectSheet()" />
<label for="protect_sheet">Protect Sheet</label>
</div>
<div class="option-group">
<input type="checkbox" id="lock_slicer" [disabled]="disableForm" [(ngModel)]="lockSlicer" (change)="updateLockSlicer()" />
<label for="lock_slicer">Lock Slicer</label>
</div>
<hr>
<div class="option-group">
<input type="radio" name="dynamic_move_size" id="slicer_move_size" [disabled]="disableForm" :checked="!dynamicMove" (change)="movesize()" />
<label for="slicer_move_size">Move and size with cells</label>
</div>
<div class="option-group">
<input type="radio" name="dynamic_move_size" [disabled]="disableForm" id="slicer_move_no_size" :checked="dynamicMove && !dynamicSize" (change)="movenosize()" />
<label for="slicer_move_no_size">Move and don't size with cells</label>
</div>
<div class="option-group">
<input type="radio" name="dynamic_move_size" [disabled]="disableForm" id="slicer_no_move_size" :checked="dynamicMove && dynamicSize" (change)="nomovesize()" />
<label for="slicer_no_move_size">Don't move and size with cells</label>
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: auto;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-group {
margin-bottom: 6px;
}
label {
display: inline-block;
min-width: 90px;
margin: 6px 0;
}
input {
padding: 4px 6px;
box-sizing: border-box;
margin-bottom: 6px;
}
hr {
border-color: #fff;
opacity: .2;
margin: 12px 0;
}
p {
padding: 2px 10px;
background-color: #F4F8EB;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-slicers': 'npm:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);